<center><a href="aij.h">Actual source code: aij.h</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:22:46+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">

<a name="line5"> 5: </a> #include <A href="../../../../../src/mat/matimpl.h.html">src/mat/matimpl.h</A>
<a name="line6">  6: </a><font color="#B22222">/*  </font>
<a name="line7">  7: </a><font color="#B22222">    Struct header shared by SeqAIJ, SeqBAIJ and SeqSBAIJ matrix formats</font>
<a name="line8">  8: </a><font color="#B22222">*/</font>
<a name="line9">  9: </a><strong><font color="#228B22">#define SEQAIJHEADER \</font></strong>
<a name="line10"> 10: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        sorted;           </font><font color="#B22222">/* if true, rows are sorted by increasing columns */</font><font color="#228B22">\</font></strong>
<a name="line11"> 11: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        roworiented;      </font><font color="#B22222">/* if true, row-oriented input, default */</font><font color="#228B22">\</font></strong>
<a name="line12"> 12: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          nonew;            </font><font color="#B22222">/* 1 don't add new nonzeros, -1 generate error on new */</font><font color="#228B22">\</font></strong>
<a name="line13"> 13: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        singlemalloc;     </font><font color="#B22222">/* if true a, i, and j have been obtained with one big malloc */</font><font color="#228B22">\</font></strong>
<a name="line14"> 14: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          maxnz;            </font><font color="#B22222">/* allocated nonzeros */</font><font color="#228B22">\</font></strong>
<a name="line15"> 15: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          *imax;            </font><font color="#B22222">/* maximum space allocated for each row */</font><font color="#228B22">\</font></strong>
<a name="line16"> 16: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          *ilen;            </font><font color="#B22222">/* actual length of each row */</font><font color="#228B22">\</font></strong>
<a name="line17"> 17: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          reallocs;         </font><font color="#B22222">/* number of mallocs done during <A href="../../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>() \</font></strong>
<a name="line18"> 18: </a><strong><font color="#B22222">                                        as more values are set than were prealloced */</font><font color="#228B22">\</font></strong>
<a name="line19"> 19: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          rmax;             </font><font color="#B22222">/* max nonzeros in any row */</font><font color="#228B22">\</font></strong>
<a name="line20"> 20: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        keepzeroedrows;   </font><font color="#B22222">/* keeps matrix structure same in calls to <A href="../../../../../docs/manualpages/Mat/MatZeroRows.html#MatZeroRows">MatZeroRows</A>()*/</font><font color="#228B22">\</font></strong>
<a name="line21"> 21: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        ignorezeroentries; \</font></strong>
<a name="line22"> 22: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          *xtoy,*xtoyB;     </font><font color="#B22222">/* map nonzero pattern of X into Y's, used by <A href="../../../../../docs/manualpages/Mat/MatAXPY.html#MatAXPY">MatAXPY</A>() */</font><font color="#228B22">\</font></strong>
<a name="line23"> 23: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>               XtoY;             </font><font color="#B22222">/* used by <A href="../../../../../docs/manualpages/Mat/MatAXPY.html#MatAXPY">MatAXPY</A>() */</font><font color="#228B22">\</font></strong>
<a name="line24"> 24: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        free_ij;          </font><font color="#B22222">/* free the column indices j and row offsets i when the matrix is destroyed */</font><font color="#228B22"> \</font></strong>
<a name="line25"> 25: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        free_a;           </font><font color="#B22222">/* free the numerical values when matrix is destroy */</font><font color="#228B22"> \</font></strong>
<a name="line26"> 26: </a><strong><font color="#228B22">  Mat_CompressedRow compressedrow;    </font><font color="#B22222">/* use compressed row format */</font><font color="#228B22">                      \</font></strong>
<a name="line27"> 27: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          nz;               </font><font color="#B22222">/* nonzeros */</font><font color="#228B22">                                       \</font></strong>
<a name="line28"> 28: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          *i;               </font><font color="#B22222">/* pointer to beginning of each row */</font><font color="#228B22">               \</font></strong>
<a name="line29"> 29: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          *j;               </font><font color="#B22222">/* column values: j + i[k] - 1 is start of row k */</font><font color="#228B22">  \</font></strong>
<a name="line30"> 30: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          *diag;            </font><font color="#B22222">/* pointers to diagonal elements */</font><font color="#228B22">                  \</font></strong>
<a name="line31"> 31: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>       *a;               </font><font color="#B22222">/* nonzero elements */</font><font color="#228B22">                               \</font></strong>
<a name="line32"> 32: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>       *solve_work;      </font><font color="#B22222">/* work space used in <A href="../../../../../docs/manualpages/Mat/MatSolve.html#MatSolve">MatSolve</A> */</font><font color="#228B22">                    \</font></strong>
<a name="line33"> 33: </a><strong><font color="#228B22">  <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>                row, col, icol    </font><font color="#B22222">/* index sets, used for reorderings */</font><font color="#228B22">               </font></strong>

<a name="line35"> 35: </a><font color="#B22222">/*  </font>
<a name="line36"> 36: </a><font color="#B22222">  <A href="../../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A> format - Compressed row storage (also called Yale sparse matrix</font>
<a name="line37"> 37: </a><font color="#B22222">  format) or compressed sparse row (CSR).  The i[] and j[] arrays start at 0. For example,</font>
<a name="line38"> 38: </a><font color="#B22222">  j[i[k]+p] is the pth column in row k.  Note that the diagonal</font>
<a name="line39"> 39: </a><font color="#B22222">  matrix elements are stored with the rest of the nonzeros (not separately).</font>
<a name="line40"> 40: </a><font color="#B22222">*/</font>

<a name="line42"> 42: </a><font color="#B22222">/* Info about i-nodes (identical nodes) helper class for SeqAIJ */</font>
<a name="line43"> 43: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line44"> 44: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> use;
<a name="line45"> 45: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   node_count;                    <font color="#B22222">/* number of inodes */</font>
<a name="line46"> 46: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   *<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>;                         <font color="#B22222">/* <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> of each inode */</font>
<a name="line47"> 47: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   limit;                         <font color="#B22222">/* inode limit */</font>
<a name="line48"> 48: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   max_limit;                     <font color="#B22222">/* maximum supported inode limit */</font>
<a name="line49"> 49: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> checked;                       <font color="#B22222">/* if inodes have been checked for */</font>
<a name="line50"> 50: </a>} Mat_Inode;

<a name="line52"> 52: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatView_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>)</font></strong>;
<a name="line53"> 53: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatAssemblyEnd_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatAssemblyType.html#MatAssemblyType">MatAssemblyType</A>)</font></strong>;
<a name="line54"> 54: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDestroy_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line55"> 55: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatCreate_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line56"> 56: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSetOption_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatOption.html#MatOption">MatOption</A>)</font></strong>;
<a name="line57"> 57: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDuplicate_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A> cpvalues,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *B)</font></strong>;
<a name="line58"> 58: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatILUDTFactor_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> isrow,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> iscol,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *fact)</font></strong>;
<a name="line59"> 59: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLUFactorSymbolic_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> isrow,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> iscol,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *fact)</font></strong>;
<a name="line60"> 60: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatILUFactorSymbolic_Inode(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> isrow,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> iscol,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *fact)</font></strong>;


<a name="line63"> 63: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line64"> 64: </a>  SEQAIJHEADER;
<a name="line65"> 65: </a>  Mat_Inode    inode;
<a name="line66"> 66: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  *saved_values;    <font color="#B22222">/* location for stashing nonzero values of matrix */</font>
<a name="line67"> 67: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  *idiag,*ssor;     <font color="#B22222">/* inverse of diagonal entries; space for eisen */</font>
<a name="line68"> 68: </a>  <A href="../../../../../docs/manualpages/IS/ISColoring.html#ISColoring">ISColoring</A>   coloring;         <font color="#B22222">/* set with MatADSetColoring() used by MatADSetValues() */</font>
<a name="line69"> 69: </a>} Mat_SeqAIJ;

<a name="line71"> 71: </a><font color="#B22222">/*</font>
<a name="line72"> 72: </a><font color="#B22222">    Frees the a, i, and j arrays from the XAIJ (AIJ, BAIJ, and SBAIJ) matrix types</font>
<a name="line73"> 73: </a><font color="#B22222">*/</font>
<a name="line76"> 76: </a><strong><font color="#4169E1"><a name="MatSeqXAIJFreeAIJ"></a>PETSC_STATIC_INLINE <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSeqXAIJFreeAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> AA,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> **a,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> **j,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> **i)</font></strong> {
<a name="line78"> 78: </a>                                     Mat_SeqAIJ     *A = (Mat_SeqAIJ*) AA-&gt;data;
<a name="line79"> 79: </a>                                     <font color="#4169E1">if</font> (A-&gt;singlemalloc) {
<a name="line80"> 80: </a>                                       <A href="../../../../../docs/manualpages/Sys/PetscFree3.html#PetscFree3">PetscFree3</A>(*a,*j,*i);
<a name="line81"> 81: </a>                                     } <font color="#4169E1">else</font> {
<a name="line82"> 82: </a>                                       <font color="#4169E1">if</font> (A-&gt;free_a  &amp;&amp; *a) {<A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(*a);}
<a name="line83"> 83: </a>                                       <font color="#4169E1">if</font> (A-&gt;free_ij &amp;&amp; *j) {<A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(*j);}
<a name="line84"> 84: </a>                                       <font color="#4169E1">if</font> (A-&gt;free_ij &amp;&amp; *i) {<A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(*i);}
<a name="line85"> 85: </a>                                     }
<a name="line86"> 86: </a>                                     *a = 0; *j = 0; *i = 0;
<a name="line87"> 87: </a>                                     <font color="#4169E1">return</font> 0;
<a name="line88"> 88: </a>                                   }

<a name="line90"> 90: </a><font color="#B22222">/*</font>
<a name="line91"> 91: </a><font color="#B22222">    Allocates larger a, i, and j arrays for the XAIJ (AIJ, BAIJ, and SBAIJ) matrix types</font>
<a name="line92"> 92: </a><font color="#B22222">*/</font>
<a name="line93"> 93: </a><strong><font color="#228B22">#define MatSeqXAIJReallocateAIJ(Amat,AM,BS2,NROW,ROW,COL,RMAX,AA,AI,AJ,RP,AP,AIMAX,NONEW) \</font></strong>
<a name="line94"> 94: </a><strong><font color="#228B22">      if (NROW &gt;= RMAX) { \</font></strong>
<a name="line95"> 95: </a><strong><font color="#228B22">        Mat_SeqAIJ *Ain = (Mat_SeqAIJ*)Amat-&gt;data;\</font></strong>
<a name="line96"> 96: </a><strong><font color="#228B22">        </font><font color="#B22222">/* there is no extra room in row, therefore enlarge */</font><font color="#228B22"> \</font></strong>
<a name="line97"> 97: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    new_nz = AI[AM] + CHUNKSIZE,len,*new_i=0,*new_j=0; \</font></strong>
<a name="line98"> 98: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *new_a; \</font></strong>
<a name="line99"> 99: </a><strong><font color="#228B22"> \</font></strong>
<a name="line100">100: </a><strong><font color="#228B22">        if (NONEW == -2) <A href="../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_ARG_OUTOFRANGE,</font><font color="#666666">"New nonzero at (%D,%D) caused a malloc"</font><font color="#228B22">,ROW,COL); \</font></strong>
<a name="line101">101: </a><strong><font color="#228B22">        </font><font color="#B22222">/* malloc new storage space */</font><font color="#228B22"> \</font></strong>
<a name="line102">102: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscMalloc3.html#PetscMalloc3">PetscMalloc3</A>(BS2*new_nz,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>,&amp;new_a,new_nz,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,&amp;new_j,AM+1,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,&amp;new_i);\</font></strong>
<a name="line103">103: </a><strong><font color="#228B22"> \</font></strong>
<a name="line104">104: </a><strong><font color="#228B22">        </font><font color="#B22222">/* copy over old data into new slots */</font><font color="#228B22"> \</font></strong>
<a name="line105">105: </a><strong><font color="#228B22">        for (ii=0; ii&lt;ROW+1; ii++) {new_i[ii] = AI[ii];} \</font></strong>
<a name="line106">106: </a><strong><font color="#228B22">        for (ii=ROW+1; ii&lt;AM+1; ii++) {new_i[ii] = AI[ii]+CHUNKSIZE;} \</font></strong>
<a name="line107">107: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(new_j,AJ,(AI[ROW]+NROW)*sizeof(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)); \</font></strong>
<a name="line108">108: </a><strong><font color="#228B22">        len = (new_nz - CHUNKSIZE - AI[ROW] - NROW); \</font></strong>
<a name="line109">109: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(new_j+AI[ROW]+NROW+CHUNKSIZE,AJ+AI[ROW]+NROW,len*sizeof(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)); \</font></strong>
<a name="line110">110: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(new_a,AA,BS2*(AI[ROW]+NROW)*sizeof(<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>)); \</font></strong>
<a name="line111">111: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>(new_a+BS2*(AI[ROW]+NROW),BS2*CHUNKSIZE*sizeof(MatScalar));\</font></strong>
<a name="line112">112: </a><strong><font color="#228B22">        <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(new_a+BS2*(AI[ROW]+NROW+CHUNKSIZE),AA+BS2*(AI[ROW]+NROW),BS2*len*sizeof(<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>));  \</font></strong>
<a name="line113">113: </a><strong><font color="#228B22">        </font><font color="#B22222">/* free up old matrix storage */</font><font color="#228B22"> \</font></strong>
<a name="line114">114: </a><strong><font color="#228B22">        MatSeqXAIJFreeAIJ(A,&amp;Ain-&gt;a,&amp;Ain-&gt;j,&amp;Ain-&gt;i);\</font></strong>
<a name="line115">115: </a><strong><font color="#228B22">        AA = Ain-&gt;a = new_a; AI = Ain-&gt;i = new_i; AJ = Ain-&gt;j = new_j;  \</font></strong>
<a name="line116">116: </a><strong><font color="#228B22">        Ain-&gt;singlemalloc = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>; \</font></strong>
<a name="line117">117: </a><strong><font color="#228B22"> \</font></strong>
<a name="line118">118: </a><strong><font color="#228B22">        RP          = AJ + AI[ROW]; AP = AA + BS2*AI[ROW]; \</font></strong>
<a name="line119">119: </a><strong><font color="#228B22">        RMAX        = AIMAX[ROW] = AIMAX[ROW] + CHUNKSIZE; \</font></strong>
<a name="line120">120: </a><strong><font color="#228B22">        Ain-&gt;maxnz += CHUNKSIZE; \</font></strong>
<a name="line121">121: </a><strong><font color="#228B22">        Ain-&gt;reallocs++; \</font></strong>
<a name="line122">122: </a><strong><font color="#228B22">      } \</font></strong>

<a name="line125">125: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSeqAIJSetPreallocation_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*)</font></strong>;
<a name="line127">127: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatILUFactorSymbolic_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *)</font></strong>;
<a name="line128">128: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatICCFactorSymbolic_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *)</font></strong>;
<a name="line129">129: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatCholeskyFactorSymbolic_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line130">130: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatCholeskyFactorNumeric_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line131">131: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDuplicate_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line132">132: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMissingDiagonal_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>*,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*)</font></strong>;
<a name="line133">133: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMarkDiagonal_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;

<a name="line135">135: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMult_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line136">136: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMultAdd_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line137">137: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMultTranspose_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line138">138: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMultTransposeAdd_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line139">139: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatRelax_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Mat/MatSORType.html#MatSORType">MatSORType</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;

<a name="line141">141: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSetColoring_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/ISColoring.html#ISColoring">ISColoring</A>)</font></strong>;
<a name="line142">142: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSetValuesAdic_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,void*)</font></strong>;
<a name="line143">143: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSetValuesAdifor_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,void*)</font></strong>;

<a name="line145">145: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatGetSymbolicTranspose_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *[],<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *[])</font></strong>;
<a name="line146">146: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatGetSymbolicTransposeReduced_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *[],<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *[])</font></strong>;
<a name="line147">147: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatRestoreSymbolicTranspose_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *[],<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *[])</font></strong>;
<a name="line148">148: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatToSymmetricIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>**,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>**)</font></strong>;
<a name="line149">149: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLUFactorSymbolic_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line150">150: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLUFactorNumeric_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line151">151: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLUFactor_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*)</font></strong>;
<a name="line152">152: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSolve_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line153">153: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSolveAdd_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line154">154: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSolveTranspose_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line155">155: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSolveTransposeAdd_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line156">156: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMatSolve_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line157">157: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatEqual_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> B,<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>* flg)</font></strong>;
<a name="line158">158: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatFDColoringCreate_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/ISColoring.html#ISColoring">ISColoring</A>,<A href="../../../../../docs/manualpages/Mat/MatFDColoring.html#MatFDColoring">MatFDColoring</A>)</font></strong>;
<a name="line159">159: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatILUDTFactor_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line160">160: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLoad_SeqAIJ(<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>, <A href="../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line161">161: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> RegisterApplyPtAPRoutines_Private(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line162">162: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMatMult_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line163">163: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMatMultSymbolic_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line164">164: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMatMultNumeric_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line165">165: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatPtAPSymbolic_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line166">166: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatPtAPNumeric_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line167">167: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatPtAPSymbolic_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line168">168: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatPtAPNumeric_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line169">169: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMatMultTranspose_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line170">170: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMatMultTransposeSymbolic_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line171">171: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMatMultTransposeNumeric_SeqAIJ_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)</font></strong>;
<a name="line172">172: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSetValues_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,const <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>[],<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,const <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>[],const <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>[],<A href="../../../../../docs/manualpages/Sys/InsertMode.html#InsertMode">InsertMode</A>)</font></strong>;
<a name="line173">173: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatGetRow_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>**,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>**)</font></strong>;
<a name="line174">174: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatRestoreRow_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>**,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>**)</font></strong>;
<a name="line175">175: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatAXPY_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A>)</font></strong>;

<a name="line178">178: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_SeqAIJ_SeqSBAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>, <A href="../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A>,<A href="../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line179">179: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_SeqAIJ_SeqBAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>, <A href="../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A>,<A href="../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line180">180: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_SeqAIJ_SeqCSRPERM(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A>,<A href="../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line181">181: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatReorderForNonzeroDiagonal_SeqAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>)</font></strong>;

<a name="line184">184: </a><font color="#A020F0">#endif</font>
</pre>
</body>

</html>
